#
# General definitions.
#

# System type.

ENV_SYSTEM = UNIX

# Installation directory.

#OSE_ROOT_DIRECTORY = /usr/local/ose
#OSE_RELEASE_DIRECTORY = tst

# Default and desired C++ compilers.

DEFAULTC++COMPILER = XL1.1
C++COMPILERS = XL1.1

# Default and desired compilation variants.

DEFAULTVARIANT = dbg
VARIANTS = dbg opt prf std

#
# Default library management definitions.
#

define DEFAULT_LIB_CLOSURE
endef

define DEFAULT_LIB_ARCHIVE
$(AR) rv @LIB@ @OBJECTS@
endef

define DEFAULT_LIB_EXTRACT
$(AR) xv @LIB@
endef

define DEFAULT_PIC_CLOSURE
endef

define DEFAULT_PIC_ARCHIVE
$(AR) rv @LIB@ @OBJECTS@
endef

define DEFAULT_PIC_EXTRACT
$(AR) xv @LIB@
endef

define DEFAULT_PIC_LIBRARY
exit 1; *** do not know how to create shared library ***
endef

#
# Compiler definitions.
#

# GNU C++ 2.7.2.

ifeq "$(C++COMPILERENV)" ""

GNU2.7.2_VARIANTS = dbg opt prf std
GNU2.7.2_PIC_VARIANTS =

GNU2.7.2_ENV_OODBMS =

GNU2.7.2_OPT_LIBRARIES =

GNU2.7.2_C++ = /usr/local/bin/g++
GNU2.7.2_CC = /usr/local/bin/gcc
GNU2.7.2_LD = /bin/ld
GNU2.7.2_AR = /bin/ar

GNU2.7.2_CPPFLAGS =
GNU2.7.2_CFLAGS = -V 2.7.2 -pipe
GNU2.7.2_C++FLAGS = -V 2.7.2 -pipe
GNU2.7.2_LDFLAGS =
GNU2.7.2_LDLIBS = -lm

GNU2.7.2_PIC_CPPFLAGS =
GNU2.7.2_PIC_CFLAGS =
GNU2.7.2_PIC_C++FLAGS =
GNU2.7.2_PIC_LDFLAGS =
GNU2.7.2_PIC_LDLIBS =

GNU2.7.2_CPPFLAGS_dbg =
GNU2.7.2_CFLAGS_dbg = -g
GNU2.7.2_C++FLAGS_dbg = -g
GNU2.7.2_LDFLAGS_dbg =
GNU2.7.2_LDLIBS_dbg =

GNU2.7.2_CPPFLAGS_opt = -DNDEBUG
GNU2.7.2_CFLAGS_opt = -O
GNU2.7.2_C++FLAGS_opt = -O
GNU2.7.2_LDFLAGS_opt =
GNU2.7.2_LDLIBS_opt =

GNU2.7.2_CPPFLAGS_prf =
GNU2.7.2_CFLAGS_prf = -pg
GNU2.7.2_C++FLAGS_prf = -pg
GNU2.7.2_LDFLAGS_prf =
GNU2.7.2_LDLIBS_prf =

GNU2.7.2_CPPFLAGS_std =
GNU2.7.2_CFLAGS_std =
GNU2.7.2_C++FLAGS_std =
GNU2.7.2_LDFLAGS_std =
GNU2.7.2_LDLIBS_std =

endif

# IBM XL C++ 1.1.

ifeq "$(C++COMPILERENV)" ""

XL1.1_VARIANTS = dbg opt prf std
XL1.1_PIC_VARIANTS =

XL1.1_ENV_OODBMS =

XL1.1_OPT_LIBRARIES =

XL1.1_C++ = /bin/xlC
XL1.1_CC = /bin/xlc
XL1.1_LD = /bin/ld
XL1.1_AR = /bin/ar

XL1.1_CPPFLAGS =
XL1.1_CFLAGS =
XL1.1_C++FLAGS =
XL1.1_LDFLAGS =
XL1.1_LDLIBS =

XL1.1_PIC_CPPFLAGS =
XL1.1_PIC_CFLAGS =
XL1.1_PIC_C++FLAGS =
XL1.1_PIC_LDFLAGS =
XL1.1_PIC_LDLIBS =

XL1.1_CPPFLAGS_dbg =
XL1.1_CFLAGS_dbg = -g
XL1.1_C++FLAGS_dbg = -g
XL1.1_LDFLAGS_dbg =
XL1.1_LDLIBS_dbg =

XL1.1_CPPFLAGS_opt = -DNDEBUG
XL1.1_CFLAGS_opt = -O
XL1.1_C++FLAGS_opt = -O
XL1.1_LDFLAGS_opt =
XL1.1_LDLIBS_opt =

XL1.1_CPPFLAGS_prf =
XL1.1_CFLAGS_prf = -pg
XL1.1_C++FLAGS_prf = -pg
XL1.1_LDFLAGS_prf =
XL1.1_LDLIBS_prf =

XL1.1_CPPFLAGS_std =
XL1.1_CFLAGS_std =
XL1.1_C++FLAGS_std =
XL1.1_LDFLAGS_std =
XL1.1_LDLIBS_std =

endif
