#
# General definitions.
#

# System type.

ENV_SYSTEM = WIN32

# Tool set.
#
# When using Cygnus Win32 Toolkit, have to use workaround to handle fact
# that bash doesn't remove carriage returns from output of DOS program
# when it forms part of a sequence of commands.
#
# Note that in this file the '^M' is a real carriage return character and
# not a caret followed by 'M'. Thus don't do a cut and paste.
#

#ENV_TOOLSET = MKS
ENV_TOOLSET = CYGWIN

# Installation directory.

OSE_ROOT_DIRECTORY = c:/ose
#OSE_RELEASE_DIRECTORY = tst

# Default and desired C++ compilers.

DEFAULTC++COMPILER = MS6.0
C++COMPILERS = MS6.0

# Default and desired compilation variants.

#DEFAULTVARIANT = dbg
#VARIANTS = dbg opt std
DEFAULTVARIANT = std
VARIANTS = std opt

#
# Default library management definitions.
#

define DEFAULT_SYM_CLEANUP
endef

ifeq "$(ENV_TOOLSET)" "CYGWIN"

define DEFAULT_LIB_CLOSURE
endef

define DEFAULT_LIB_ARCHIVE
$(AR) -out:@LIB@ @ALLOBJECTS@
endef

define DEFAULT_LIB_EXTRACT
for obj in `$(AR) @LIB@ /NOLOGO /LIST`; do \
 $(AR) @LIB@ /NOLOGO /EXTRACT:`echo $${obj} | tr '
' ' '`; done
endef

#define DEFAULT_LIB_EXTRACT
#for obj in `$(AR) @LIB@ /NOLOGO /LIST | tr '
' ' ' | sed -e 's/ //'`; do \
# $(AR) @LIB@ /NOLOGO /EXTRACT:`echo $${obj}`; done
#endef

define DEFAULT_PIC_CLOSURE
endef

define DEFAULT_PIC_ARCHIVE
$(AR) -out:@LIB@ @ALLOBJECTS@
endef

define DEFAULT_PIC_EXTRACT
for obj in `$(AR) @LIB@ /NOLOGO /LIST`; do \
 $(AR) @LIB@ /NOLOGO /EXTRACT:`echo $${obj} | tr '
' ' '`; done
endef

#define DEFAULT_PIC_EXTRACT
#for obj in `$(AR) @LIB@ /NOLOGO /LIST | tr '
' ' ' | sed -e 's/ //'`; do \
# $(AR) @LIB@ /NOLOGO /EXTRACT:`echo $${obj} | tr '
' ' '`; done
#endef

define DEFAULT_PIC_LIBRARY
LIB="@LIBPATH@" lib="@LIBPATH@" \
 $(C++) /LD -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

else

define DEFAULT_LIB_CLOSURE
endef

define DEFAULT_LIB_ARCHIVE
$(AR) -out:@LIB@ @ALLOBJECTS@
endef

define DEFAULT_LIB_EXTRACT
for obj in `$(AR) @LIB@ /NOLOGO /LIST`; do \
 $(AR) @LIB@ /NOLOGO /EXTRACT:$${obj}; done
endef

define DEFAULT_PIC_CLOSURE
endef

define DEFAULT_PIC_ARCHIVE
$(AR) -out:@LIB@ @ALLOBJECTS@
endef

define DEFAULT_PIC_EXTRACT
for obj in `$(AR) @LIB@ /NOLOGO /LIST`; do \
 $(AR) @LIB@ /NOLOGO /EXTRACT:$${obj}; done
endef

define DEFAULT_PIC_LIBRARY
LIB="@LIBPATH@" lib="@LIBPATH@" \
 $(C++) /LD -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif

#
# Compiler definitions.
#

# Microsoft C++ 2.0.

ifeq "$(C++COMPILERENV)" ""

MS2.0_VARIANTS = dbg opt std
MS2.0_PIC_VARIANTS =

MS2.0_ENV_OODBMS =

MS2.0_OPT_LIBRARIES =

MS2.0_C++ = E:/MSVC20/BIN/cl
MS2.0_CC = E:/MSVC20/BIN/cl
MS2.0_LD = E:/MSVC20/BIN/cl
MS2.0_AR = E:/MSVC20/BIN/LIB

MS2.0_CPPFLAGS =
MS2.0_CFLAGS =
MS2.0_C++FLAGS =
MS2.0_LDFLAGS =
MS2.0_LDLIBS =

MS2.0_PIC_CPPFLAGS =
MS2.0_PIC_CFLAGS =
MS2.0_PIC_C++FLAGS =
MS2.0_PIC_LDFLAGS =
MS2.0_PIC_LDLIBS =

MS2.0_CPPFLAGS_dbg =
MS2.0_CFLAGS_dbg = -Z7
MS2.0_C++FLAGS_dbg = -Z7
MS2.0_LDFLAGS_dbg =
MS2.0_LDLIBS_dbg =

MS2.0_CPPFLAGS_opt = -DNDEBUG
MS2.0_CFLAGS_opt = -O
MS2.0_C++FLAGS_opt = -O
MS2.0_LDFLAGS_opt =
MS2.0_LDLIBS_opt =

MS2.0_CPPFLAGS_prf =
MS2.0_CFLAGS_prf =
MS2.0_C++FLAGS_prf =
MS2.0_LDFLAGS_prf =
MS2.0_LDLIBS_prf =

MS2.0_CPPFLAGS_std =
MS2.0_CFLAGS_std =
MS2.0_C++FLAGS_std =
MS2.0_LDFLAGS_std =
MS2.0_LDLIBS_std =

endif

# Microsoft C++ 4.1.

ifeq "$(C++COMPILERENV)" ""

MS4.1_VARIANTS = dbg opt std
MS4.1_PIC_VARIANTS =

MS4.1_ENV_OODBMS =

MS4.1_OPT_LIBRARIES =

MS4.1_C++ = E:/MSDEV/BIN/cl
MS4.1_CC = E:/MSDEV/BIN/cl
MS4.1_LD = E:/MSDEV/BIN/cl
MS4.1_AR = E:/MSDEV/BIN/lib

MS4.1_CPPFLAGS =
MS4.1_CFLAGS =
MS4.1_C++FLAGS =
MS4.1_LDFLAGS =
MS4.1_LDLIBS =

MS4.1_PIC_CPPFLAGS =
MS4.1_PIC_CFLAGS =
MS4.1_PIC_C++FLAGS =
MS4.1_PIC_LDFLAGS =
MS4.1_PIC_LDLIBS =

MS4.1_CPPFLAGS_dbg =
MS4.1_CFLAGS_dbg = -Z7
MS4.1_C++FLAGS_dbg = -Z7
MS4.1_LDFLAGS_dbg =
MS4.1_LDLIBS_dbg =

MS4.1_CPPFLAGS_opt = -DNDEBUG
MS4.1_CFLAGS_opt = -O
MS4.1_C++FLAGS_opt = -O
MS4.1_LDFLAGS_opt =
MS4.1_LDLIBS_opt =

MS4.1_CPPFLAGS_prf =
MS4.1_CFLAGS_prf =
MS4.1_C++FLAGS_prf =
MS4.1_LDFLAGS_prf =
MS4.1_LDLIBS_prf =

MS4.1_CPPFLAGS_std =
MS4.1_CFLAGS_std =
MS4.1_C++FLAGS_std =
MS4.1_LDFLAGS_std =
MS4.1_LDLIBS_std =

endif

ifeq "$(C++COMPILERENV)" "OSTORE"

MS4.1_VARIANTS = dbg opt std
MS4.1_PIC_VARIANTS =

MS4.1_ENV_OODBMS = OSTORE

MS4.1_OPT_LIBRARIES =

MS4.1_C++ = E:/MSDEV/BIN/cl
MS4.1_CC = E:/MSDEV/BIN/cl
MS4.1_LD = E:/MSDEV/BIN/cl
MS4.1_AR = E:/MSDEV/BIN/lib

MS4.1_CPPFLAGS =
MS4.1_CFLAGS =
MS4.1_C++FLAGS =
MS4.1_LDFLAGS =
MS4.1_LDLIBS =

MS4.1_PIC_CPPFLAGS =
MS4.1_PIC_CFLAGS =
MS4.1_PIC_C++FLAGS =
MS4.1_PIC_LDFLAGS =
MS4.1_PIC_LDLIBS =

MS4.1_CPPFLAGS_dbg =
MS4.1_CFLAGS_dbg = -Z7
MS4.1_C++FLAGS_dbg = -Z7
MS4.1_LDFLAGS_dbg =
MS4.1_LDLIBS_dbg =

MS4.1_CPPFLAGS_opt = -DNDEBUG
MS4.1_CFLAGS_opt = -O
MS4.1_C++FLAGS_opt = -O
MS4.1_LDFLAGS_opt =
MS4.1_LDLIBS_opt =

MS4.1_CPPFLAGS_prf =
MS4.1_CFLAGS_prf =
MS4.1_C++FLAGS_prf =
MS4.1_LDFLAGS_prf =
MS4.1_LDLIBS_prf =

MS4.1_CPPFLAGS_std =
MS4.1_CFLAGS_std =
MS4.1_C++FLAGS_std =
MS4.1_LDFLAGS_std =
MS4.1_LDLIBS_std =

endif

ifeq "$(C++COMPILERENV)" "THREAD"

MS4.1_VARIANTS = dbg opt std
MS4.1_PIC_VARIANTS = dbg opt std

MS4.1_ENV_OODBMS =

MS4.1_OPT_LIBRARIES =

MS4.1_C++ = /MSDEV/BIN/cl
MS4.1_CC = /MSDEV/BIN/cl
MS4.1_LD = /MSDEV/BIN/cl
MS4.1_AR = /MSDEV/BIN/lib

MS4.1_CPPFLAGS = -DHAVE_WIN32_THREADS
MS4.1_CFLAGS =
MS4.1_C++FLAGS =
MS4.1_LDFLAGS =
MS4.1_LDLIBS =

MS4.1_PIC_CPPFLAGS =
MS4.1_PIC_CFLAGS = -DPIC_WIN32
MS4.1_PIC_C++FLAGS = -DPIC_WIN32
MS4.1_PIC_LDFLAGS =
MS4.1_PIC_LDLIBS =

MS4.1_CPPFLAGS_dbg =
MS4.1_CFLAGS_dbg = -Z7
MS4.1_C++FLAGS_dbg = -Z7
MS4.1_LDFLAGS_dbg =
MS4.1_LDLIBS_dbg =

MS4.1_CPPFLAGS_opt = -DNDEBUG
MS4.1_CFLAGS_opt = -O
MS4.1_C++FLAGS_opt = -O
MS4.1_LDFLAGS_opt =
MS4.1_LDLIBS_opt =

MS4.1_CPPFLAGS_prf =
MS4.1_CFLAGS_prf =
MS4.1_C++FLAGS_prf =
MS4.1_LDFLAGS_prf =
MS4.1_LDLIBS_prf =

MS4.1_CPPFLAGS_std =
MS4.1_CFLAGS_std =
MS4.1_C++FLAGS_std =
MS4.1_LDFLAGS_std =
MS4.1_LDLIBS_std =

endif

ifeq "$(C++COMPILERENV)" "THREAD"

MS5.0_VARIANTS = dbg opt std
MS5.0_PIC_VARIANTS = dbg opt std

MS5.0_ENV_OODBMS =

MS5.0_OPT_LIBRARIES =

MS5.0_C++ = d:/DEVSTUDIO/VC/BIN/cl
MS5.0_CC = d:/DEVSTUDIO/VC/BIN/cl
MS5.0_LD = d:/DEVSTUDIO/VC/BIN/cl
MS5.0_AR = d:/DEVSTUDIO/VC/BIN/lib

MS5.0_CPPFLAGS = -DHAVE_WIN32_THREADS
MS5.0_CFLAGS =
MS5.0_C++FLAGS =
MS5.0_LDFLAGS =
MS5.0_LDLIBS =

MS5.0_PIC_CPPFLAGS =
MS5.0_PIC_CFLAGS = -DPIC_WIN32
MS5.0_PIC_C++FLAGS = -DPIC_WIN32
MS5.0_PIC_LDFLAGS =
MS5.0_PIC_LDLIBS =

MS5.0_CPPFLAGS_dbg =
MS5.0_CFLAGS_dbg = -Z7
MS5.0_C++FLAGS_dbg = -Z7
MS5.0_LDFLAGS_dbg =
MS5.0_LDLIBS_dbg =

MS5.0_CPPFLAGS_opt = -DNDEBUG
MS5.0_CFLAGS_opt = -O
MS5.0_C++FLAGS_opt = -O
MS5.0_LDFLAGS_opt =
MS5.0_LDLIBS_opt =

MS5.0_CPPFLAGS_prf =
MS5.0_CFLAGS_prf =
MS5.0_C++FLAGS_prf =
MS5.0_LDFLAGS_prf =
MS5.0_LDLIBS_prf =

MS5.0_CPPFLAGS_std =
MS5.0_CFLAGS_std =
MS5.0_C++FLAGS_std =
MS5.0_LDFLAGS_std =
MS5.0_LDLIBS_std =

endif

ifeq "$(C++COMPILERENV)" ""

MS6.0_VARIANTS = dbg opt std
MS6.0_PIC_VARIANTS = dbg opt std

MS6.0_ENV_OODBMS =

MS6.0_OPT_LIBRARIES =

MS6.0_C++ = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_CC = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_LD = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_AR = c:/VISUALSTUDIO/VC98/BIN/lib

MS6.0_CPPFLAGS =
MS6.0_CFLAGS =
MS6.0_C++FLAGS =
MS6.0_LDFLAGS =
MS6.0_LDLIBS =

MS6.0_PIC_CPPFLAGS =
MS6.0_PIC_CFLAGS = -DPIC_WIN32
MS6.0_PIC_C++FLAGS = -DPIC_WIN32
MS6.0_PIC_LDFLAGS =
MS6.0_PIC_LDLIBS =

MS6.0_CPPFLAGS_dbg =
MS6.0_CFLAGS_dbg = -Z7
MS6.0_C++FLAGS_dbg = -Z7
MS6.0_LDFLAGS_dbg =
MS6.0_LDLIBS_dbg =

MS6.0_CPPFLAGS_opt = -DNDEBUG
MS6.0_CFLAGS_opt = -O
MS6.0_C++FLAGS_opt = -O
MS6.0_LDFLAGS_opt =
MS6.0_LDLIBS_opt =

MS6.0_CPPFLAGS_prf =
MS6.0_CFLAGS_prf =
MS6.0_C++FLAGS_prf =
MS6.0_LDFLAGS_prf =
MS6.0_LDLIBS_prf =

MS6.0_CPPFLAGS_std =
MS6.0_CFLAGS_std =
MS6.0_C++FLAGS_std =
MS6.0_LDFLAGS_std =
MS6.0_LDLIBS_std =

endif

ifeq "$(C++COMPILERENV)" "THREAD"

MS6.0_VARIANTS = dbg opt std
MS6.0_PIC_VARIANTS = dbg opt std

MS6.0_ENV_OODBMS =

MS6.0_OPT_LIBRARIES =

MS6.0_C++ = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_CC = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_LD = c:/VISUALSTUDIO/VC98/BIN/cl
MS6.0_AR = c:/VISUALSTUDIO/VC98/BIN/lib

MS6.0_CPPFLAGS = -DHAVE_WIN32_THREADS
MS6.0_CFLAGS =
MS6.0_C++FLAGS =
MS6.0_LDFLAGS =
MS6.0_LDLIBS =

MS6.0_PIC_CPPFLAGS =
MS6.0_PIC_CFLAGS = -DPIC_WIN32
MS6.0_PIC_C++FLAGS = -DPIC_WIN32
MS6.0_PIC_LDFLAGS =
MS6.0_PIC_LDLIBS =

MS6.0_CPPFLAGS_dbg =
MS6.0_CFLAGS_dbg = -Z7
MS6.0_C++FLAGS_dbg = -Z7
MS6.0_LDFLAGS_dbg =
MS6.0_LDLIBS_dbg =

MS6.0_CPPFLAGS_opt = -DNDEBUG
MS6.0_CFLAGS_opt = -O
MS6.0_C++FLAGS_opt = -O
MS6.0_LDFLAGS_opt =
MS6.0_LDLIBS_opt =

MS6.0_CPPFLAGS_prf =
MS6.0_CFLAGS_prf =
MS6.0_C++FLAGS_prf =
MS6.0_LDFLAGS_prf =
MS6.0_LDLIBS_prf =

MS6.0_CPPFLAGS_std =
MS6.0_CFLAGS_std =
MS6.0_C++FLAGS_std =
MS6.0_LDFLAGS_std =
MS6.0_LDLIBS_std =

endif
