import netsvc
import sys
import string
import signal

count = len(sys.argv)-1
server = None
domain = ""

args = sys.argv[1:]

def usage():
  print "Usage: proxy-client -connect server [ -domain name ]"

try:
  i = 0
  while i < count:
    if args[i] == "-connect":
      server = args[i+1]
      i = i + 2
    elif args[i] == "-domain":
      domain = args[i+1]
      i = i + 2
    else:
      usage()
      sys.exit(1)
except:
  usage()
  sys.exit(1)

if server == None:
  usage()
  sys.exit(1)


class Client(netsvc.Service):

  def __init__(self):
    netsvc.Service.__init__(self,"client")
    self._proxy = None
    self._handle = None
    self.scheduleAction(self.start,netsvc.STANDARD_JOB,"start")

  def start(self,tag):
    self._proxy = self.serviceEndPoint("proxy")
    if self._proxy != None:
      address = self._proxy.serviceAddress()
      self.subscribeServiceAddress(self.monitor,address)
      id = self._proxy.connect(("localhost",7))
      self.monitorResponse(self.active,id,10)
    else:
      self.startTimer(self.start,1,"start")

  def monitor(self,binding,group,status):
    if group == None and status == netsvc.SERVICE_WITHDRAWN:
      if self._proxy != None:
	address = self._proxy.serviceAddress()
        self.unsubscribeServiceAddress(address)
	self.cancelAllTimers()
	self._proxy = None

  def active(self,handle):
    if self.failureOccurred():
      print self.currentFailure()
    else:
      self._handle = handle
      self.acceptReports(self.data,"proxy",handle)
      self.startTimer(self.timeout,1,"send")
      self.startTimer(self.timeout,20,"close")

  def data(self,service,subjectName,content):
    sys.stdout.write(content)
    if content == "":
      if self._proxy != None:
	address = self._proxy.serviceAddress()
        self.unsubscribeServiceAddress(address)
	self.cancelAllTimers()
	self._proxy = None

  def timeout(self,name):
    if name == "send":
      if self._proxy != None:
	id = self._proxy.write(self._handle,str(netsvc.DateTime())+"\n")
	self.monitorResponse(self.result,id,2)
	self.startTimer(self.timeout,1,"send")
    else:
      self._proxy.close(self._handle)
      address = self._proxy.serviceAddress()
      self.unsubscribeServiceAddress(address)
      self._proxy = None
      self._handle = None

  def result(self,value):
    if self.failureOccurred():
      print self.currentFailure()


dispatcher = netsvc.Dispatcher()
dispatcher.monitor(signal.SIGINT)

exchange = netsvc.Exchange(netsvc.EXCHANGE_CLIENT,domain)

delay = 5
host,port = string.splitfields(server,':')
port = int(port)
exchange.connect(host,port,delay)

client = Client()

dispatcher.run()

