/*
// ============================================================================
//
// = LIBRARY
//     OTC
// 
// = FILENAME
//     python/otcpyqueue.cc
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1998-2000 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

#ifdef __GNUG__
#pragma implementation "OTC/python/pyqueue.hh"
#endif

#include <OTC/python/pyqueue.hh>
#include <OTC/python/pydsptch.hh>

#include <Python.h>

#include <OTC/debug/tracer.hh>
#include <OTC/debug/tracetag.hh>

/* ------------------------------------------------------------------------- */
#ifdef OTCLIB_TRACE
static OTC_NRMutex MODULE_TRACETAG_MUTEX;
static OTC_TraceTag& MODULE_TRACETAG()
{
  static OTC_TraceTag* TAG = 0;
  MODULE_TRACETAG_MUTEX.lock();
  if (TAG == 0)
    TAG = new OTC_TraceTag("OTC_PyJobQueue");
  MODULE_TRACETAG_MUTEX.unlock();
  return *TAG;
}

#define MODULE MODULE_TRACETAG()
#endif

/* ------------------------------------------------------------------------- */
OTC_PyJobQueue::~OTC_PyJobQueue()
{
  // Nothing to do.
}

/* ------------------------------------------------------------------------- */
OTC_PyJobQueue::OTC_PyJobQueue()
{
  // Nothing to do.
}

/* ------------------------------------------------------------------------- */
void OTC_PyJobQueue::shutdown()
{
  OTCLIB_MARKBLOCK(MODULE,"OTC_PyJobQueue::shutdown()");

  char* command = "try:\n"
		  "  Tkinter._tkinter.quit()\n"
		  "except:\n"
		  "  try:\n"
		  "    _tkinter.quit()\n"
		  "  except:\n"
		  "    pass\n";

  OTC_PyDispatcher::enterPython();

  PyRun_SimpleString(command);

  OTC_PyDispatcher::leavePython();
}

/* ------------------------------------------------------------------------- */
