/*
// ============================================================================
//
// = LIBRARY
//     OTC
// 
// = FILENAME
//     misc/otcfuncstrm.cc
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1997-2001 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

#ifdef __GNUG__
#pragma implementation "OTC/misc/funcstrm.hh"
#endif

#include <OTC/misc/funcstrm.hh>

/* ------------------------------------------------------------------------- */
OTC_FuncStream::OTC_FuncStream(
 void (*theFunc)(char const*,u_int),
 char* theBuffer,
 u_int theSize
)
  : ios(&funcBuf_), ostream(&funcBuf_), funcBuf_(theFunc,theBuffer,theSize)
  // It is believed that the following should work by itself.
  //   : ostream(&funcBuf_), funcBuf_(theFunc,theBuffer,theSize)
  // It wouldn't work however on Sun C++ 5.0 possibly because of compiler
  // or streams library bug whereby ios::init() wasn't called. Had to use:
  //   : ios(&funcBuf_), funcBuf_(theFunc,theBuffer,theSize)
  // This however wouldn't work with Visual C++ 6.0 and wasn't standard
  // anyway. Thus tried:
  //   : ostream(&funcBuf_), ios(0), funcBuf_(theFunc,theBuffer,theSize)
  // This worked on Visual C++ 6.0 but apparently still doesn't work on
  // Sun C++ 5.0 and 5.2 compiler.
  //
  // Have thus settled for initialising ios and ostream with the
  // streambuf and also calling ios::init() for good measure. This should
  // compile on everything and will also hopefully work.
{
  ios::init(&funcBuf_);
}

/* ------------------------------------------------------------------------- */
OTC_FuncStream::~OTC_FuncStream()
{
  funcBuf_.pubsync();
}

/* ------------------------------------------------------------------------- */
